﻿using Kivii.Finances.Addons.Requests;
using Kivii.Finances.Entities;
using Kivii.Linq;
using Kivii.Text;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Addons
{

    [Api(Description = "政策验证")]
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class PolicyVerifying : RestfulExecution<Policy>
    {
        public string TargetName { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            if (TargetName.IsNullOrEmpty()) throw new Exception("请传入付款单位信息!");

            var conn = KiviiContext.GetOpenedDbConnection<InvoiceTitle>();
            var query = conn.From<InvoiceTitle>();
            query.Where(o => o.CompanyName == TargetName);
            query.Select(o => new { corpName = o.CompanyName, uniscid = o.TaxNumber });
            var verifyParam = conn.Single<PolicyVerifyRequestParams>(query);
            if (verifyParam == null)
            {
                verifyParam = new PolicyVerifyRequestParams();
                verifyParam.corpName = TargetName;
                verifyParam.uniscid = "";
            }
            var rtns = new RestfulPolicyVerifyResponse();
            var client = new JsonServiceClient(Configs.UrlVerify);
            rtns = client.GetPolicyVerify(verifyParam);

            rtns.Total = rtns.Results.Count;
            return rtns;
        }
    }
}
